
/*
 * checkvalue Plug-in
 * Copyright (c) 2017 Cybozu
 *
 * Licensed under the MIT License
 */
jQuery.noConflict();
(function($, PLUGIN_ID) {
    'use strict';

    function escapeHtml(htmlstr) {
        return htmlstr.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;')
            .replace(/"/g, '&quot;').replace(/'/g, '&#39;');
    }

    $(document).ready(function() {
        var wfSNmChange = false;
        var fmSNmChange = false;
        var pssSNmChange = false;

        var CONFIG = kintone.plugin.app.getConfig(PLUGIN_ID);
        if (CONFIG) {
            $('#wfAppId').val(CONFIG.wfAppId);
            $('#fmAppId').val(CONFIG.fmAppId);
            $('#wfAppName').val(CONFIG.wfAppName);
            $('#fmAppName').val(CONFIG.fmAppName);
        }

        // 「保存する」ボタン押下時に入力情報を設定する
        $('#check-plugin-submit').click(function() {
            var config = {}; // [] から変更
            if (!($('#wfAppId').val() && $('#fmAppId').val() )) {
                alert('アプリIDの選択をしてください。');
                return;
            }
            config.wfAppId = $('#wfAppId').val();
            config.fmAppId = $('#fmAppId').val();
            config.wfAppName = $('#wfAppName').val();
            config.fmAppName = $('#fmAppName').val();

            config.pssAppId = '0'; // 変数を残しておく。申請元JSのキャッシュが古い場合を想定。
            // config.pssAppName = '';
            try {
               kintone.plugin.app.setConfig(config);
            } catch (error) {
               alert(error.message);
            }
        });

        // 「キャンセル」ボタン押下時の処理
        $('#check-plugin-cancel').click(function() {
            history.back();
        });

        // 検索キーワード変更時
        $('#wfAppNameSch').change(function() {
            wfSNmChange = true;
            $('#wfAppId').val('');
            $('#wfAppName').val('');
            var params = {
                "name": $('#wfAppNameSch').val()
            };
            kintone.api(kintone.api.url('/k/v1/apps', true), 'GET', params, function(resp) {
                // success
                console.log(resp);
                document.getElementById('wfAppId').value = '';
                document.getElementById('wfAppName').value = '';
                for (var i = document.getElementById('wfAppIdLst').childNodes.length -1; i >= 0; i--) {
                    document.getElementById('wfAppIdLst').removeChild(document.getElementById('wfAppIdLst').childNodes[i]);
                }
                for (var i = 0;i < resp.apps.length; i++) {
                    var option_add = document.createElement("option");
                    option_add.setAttribute("value", resp.apps[i].appId);
                    option_add.innerHTML = resp.apps[i].name;
                    document.getElementById('wfAppIdLst').appendChild(option_add);
                }
                if (resp.apps.length > 0) {
                    alert('ワークフロー定義アプリ候補一覧を更新しました。アプリを選択してください。');
                }
                else {
                    alert('入力されたアプリ名に該当するアプリが存在しませんでした。検索キーワードを変更し再検索してください。');
                }
            }, function(error) {
                // error
                console.log(error);
            });
        });

        // 検索ボタンクリック時
        $('#find_WFApp').click(function() {
            if (wfSNmChange == true) {
                wfSNmChange = false;
                return;
            }
            $('#wfAppId').val('');
            $('#wfAppName').val('');
            var params = {
                "name": $('#wfAppNameSch').val()
            };
            kintone.api(kintone.api.url('/k/v1/apps', true), 'GET', params, function(resp) {
                // success
                console.log(resp);
                document.getElementById('wfAppId').value = '';
                document.getElementById('wfAppName').value = '';
                for (var i = document.getElementById('wfAppIdLst').childNodes.length -1; i >= 0; i--) {
                    document.getElementById('wfAppIdLst').removeChild(document.getElementById('wfAppIdLst').childNodes[i]);
                }
                for (var i = 0;i < resp.apps.length; i++) {
                    var option_add = document.createElement("option");
                    option_add.setAttribute("value", resp.apps[i].appId);
                    option_add.innerHTML = resp.apps[i].name;
                    document.getElementById('wfAppIdLst').appendChild(option_add);
                }
                if (resp.apps.length > 0) {
                    alert('ワークフロー定義アプリ候補一覧を更新しました。アプリを選択してください。');
                }
                else {
                    alert('入力されたアプリ名に該当するアプリが存在しませんでした。検索キーワードを変更し再検索してください。');
                }
            }, function(error) {
                // error
                console.log(error);
            });
        });
        // ID直接入力時
        $('#wfAppId').change(function() {
            var ids = [];
            ids.push($('#wfAppId').val());
            var params = {
                "ids": ids
            };
            kintone.api(kintone.api.url('/k/v1/apps', true), 'GET', params, function(resp) {
                // success
                console.log(resp);
                if (resp.apps.length > 0) {
                    $('#wfAppName').val(resp.apps[0].name);
                }
                else {
                    $('#wfAppName').val('該当アプリは存在しません。');
                }
            }, function(error) {
                // error
                console.log(error);
            });
        });

        // 検索キーワード変更時
        $('#fmAppNameSch').change(function() {
            fmSNmChange = true;
            $('#fmAppId').val('');
            $('#fmAppName').val('');
            var params = {
                "name": $('#fmAppNameSch').val()
            };
            kintone.api(kintone.api.url('/k/v1/apps', true), 'GET', params, function(resp) {
                // success
                console.log(resp);
                document.getElementById('fmAppId').value = '';
                document.getElementById('fmAppName').value = '';
                for (var i = document.getElementById('fmAppIdLst').childNodes.length -1; i >= 0; i--) {
                    document.getElementById('fmAppIdLst').removeChild(document.getElementById('fmAppIdLst').childNodes[i]);
                }
                for(var i = 0;i < resp.apps.length; i++) {
                    var option_add = document.createElement("option");
                    //option_add.setAttribute("value", resp.apps[i].name + ':' + resp.apps[i].appId);
                    option_add.setAttribute("value", resp.apps[i].appId);
                    option_add.innerHTML = resp.apps[i].name;
                    document.getElementById('fmAppIdLst').appendChild(option_add);
                }
                if (resp.apps.length > 0) {
                    alert('フォーム定義アプリ候補一覧を更新しました。アプリを選択してください。');
                }
                else {
                    alert('入力されたアプリ名に該当するアプリが存在しませんでした。検索キーワードを変更し再検索してください。');
                }
            }, function(error) {
                // error
                console.log(error);
            });
        });
        // 検索ボタンクリック時
        $('#find_FMApp').click(function() {
            if (fmSNmChange == true) {
                fmSNmChange = false;
                return;
            }
            $('#fmAppId').val('');
            $('#fmAppName').val('');
            var params = {
                "name": $('#fmAppNameSch').val()
            };
            kintone.api(kintone.api.url('/k/v1/apps', true), 'GET', params, function(resp) {
                // success
                console.log(resp);
                document.getElementById('fmAppId').value = '';
                document.getElementById('fmAppName').value = '';
                for (var i = document.getElementById('fmAppIdLst').childNodes.length -1; i >= 0; i--) {
                    document.getElementById('fmAppIdLst').removeChild(document.getElementById('fmAppIdLst').childNodes[i]);
                }
                for(var i = 0;i < resp.apps.length; i++) {
                    var option_add = document.createElement("option");
                    //option_add.setAttribute("value", resp.apps[i].name + ':' + resp.apps[i].appId);
                    option_add.setAttribute("value", resp.apps[i].appId);
                    option_add.innerHTML = resp.apps[i].name;
                    document.getElementById('fmAppIdLst').appendChild(option_add);
                }
                if (resp.apps.length > 0) {
                    alert('フォーム定義アプリ候補一覧を更新しました。アプリを選択してください。');
                }
                else {
                    alert('入力されたアプリ名に該当するアプリが存在しませんでした。検索キーワードを変更し再検索してください。');
                }
            }, function(error) {
                // error
                console.log(error);
            });
        });
        // ID直接入力時
        $('#fmAppId').change(function() {
            var ids = [];
            ids.push($('#fmAppId').val());
            var params = {
                "ids": ids
            };
            kintone.api(kintone.api.url('/k/v1/apps', true), 'GET', params, function(resp) {
                // success
                console.log(resp);
                if (resp.apps.length > 0) {
                    $('#fmAppName').val(resp.apps[0].name);
                }
                else {
                    $('#fmAppName').val('該当アプリは存在しません。');
                }
            }, function(error) {
                // error
                console.log(error);
            });
        });

    });
})(jQuery, kintone.$PLUGIN_ID);
